#include windows.inc
#include kernel32.inc
#include user32.inc

.DATA
ClassName db "SimpleWinClass",0
AppName  db "Our First Window",0
hInstance dd ?
CommandLine dd ?

.CODE

start:
	invoke GetModuleHandle, NULL
	mov    [hInstance],eax
	invoke GetCommandLine
	mov    [CommandLine],eax
	invoke WinMain, [hInstance],NULL,[CommandLine], SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
        LOCAL hwnd
        mov   d[wc.cbSize],SIZEOF WNDCLASSEX
        mov   d[wc.style],CS_HREDRAW | CS_VREDRAW
        mov   d[wc.lpfnWndProc], OFFSET WndProc
        mov   d[wc.cbClsExtra],NULL
        mov   d[wc.cbWndExtra],NULL
        push  [hInstance]
        pop   [wc.hInstance]
        mov   d[wc.hbrBackground],COLOR_WINDOW+1
        mov   d[wc.lpszMenuName],NULL
        mov   d[wc.lpszClassName],OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
        mov   [wc.hIcon],eax
        mov   [wc.hIconSm],eax
	invoke LoadCursor,NULL,IDC_ARROW
        mov   [wc.hCursor],eax
	invoke RegisterClassEx,ADDR wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           [hInst],NULL
	mov   [hwnd],eax
	invoke ShowWindow,[hwnd],SW_SHOWNORMAL
	invoke UpdateWindow,[hwnd]
        msgloop:
		invoke GetMessage, ADDR msg,NULL,0,0
		or eax,eax
                jz >finish
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
        jmp msgloop
        finish:
	mov     eax,[msg.wParam]
	ret
        ENDF

WndProc FRAME hWnd,uMsg,wParam,lParam
        cmp d[uMsg],WM_DESTROY
        jne >defwndproc
		invoke PostQuitMessage,NULL
                jmp >end
        defwndproc:
	invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]		
        ret                
        end:
	xor eax,eax
	ret
        ENDF
